# -*- coding: utf-8 -*-
"""
Created on Thu Jan 31 16:54:39 2019

@author: Federico Perrone
"""
from pprint import *
from MkTable import *
from Recommended import *
from ReadKnowledgeBase import *

class Goal:
    def __init__(self, path = "Goal"):
        with open(path) as f:
            input_lines = f.readlines()
        input_lines = [x.strip() for x in input_lines 
                            if x.strip() != '' and x.strip()[0] != '\n']
        self.goals = []
        for line in input_lines:
            line = line.split(",")
            line = [x.strip() for x in line if x.strip() != '']
            self.goals.append(line) 
        print (self.goals)

    def resolve_goal(self, goal, knowledge_base):
        
        #controllo se ho già un oggetto nell'ontologia che ha tutte le proprietà che mi servono
        for object_name in knowledge_base:
            found = True
            for goal_property in goal:
                if goal_property not in knowledge_base[object_name]:
                   found = False
            if found:
                return object_name, None, None
        
        
        list_object = self.list_order_by_probability(goal, knowledge_base)
        print(list_object)
        #cerco di combinare le proprietà di due oggetti
        i = 0         
        for object_name in list_object:
            j = 0
            for object_name2 in list_object:
                if j > i:
                     all_goal_property = self.all_gaol_property(goal,knowledge_base[object_name], knowledge_base[object_name2])
                     if all_goal_property: 
                         #combinazione con la head di object_name e con il modifier object_name2
                        print("---------------------")
                        print(object_name+ " ------------------- " + object_name2)
                        print("---------------------")
                        fusion1 = HeadModifier(object_name, object_name2, knowledge_base)
                        tab = Table(fusion1)
                        recs,block = recommended(tab)
                        print(recs)
                        print(block)
                        block = self.gaol_found(recs,block, goal, fusion1, tab)
                        if block is not None:
                            return block, object_name, object_name2
                        
                        #combinazione inversa 
                        print("---------------------")
                        print(object_name2+ " ------------------- " + object_name)
                        print("---------------------")
                        fusion2 = HeadModifier(object_name2, object_name, knowledge_base)
                        tab = Table(fusion2)
                        recs, block = recommended(tab)
                        print(recs)
                        print(block)
                        block = self.gaol_found(recs, block, goal, fusion2, tab)
                        if block is not None:      
                            return block, object_name2, object_name
                j += 1
            
            i += 1
                    
                        
                     
                   
        return None, None, None
    #funzione che restituisce un lista delle proprietà del gaol se non sono presentei nell'ontologia
    def no_goal_property_in_knowledge_base(self,goal, knowledge_base):
        property_not_in_knowledge_base = []
        for goal_property in goal:
            found = False
            for object_name in knowledge_base:
                if goal_property in knowledge_base[object_name]:
                    found = True
            if found == False:
                property_not_in_knowledge_base.append(goal_property)
        return property_not_in_knowledge_base
    
    
    #questa funzione restituisce il record  raccomandato se e solo se soddisfa tutte le proprietà del goal
    # altrimenti restituisce None
    def gaol_found(self,recs, blocks, goal, fusion, tab ):
        for rec in recs:
            for block in blocks:
                found = True
                if rec == block[1]:
                    for goal_property in goal:
                        goal_prop = False
                        att = 0
                        for attrs in fusion.attrs:
                            if attrs[0] == goal_property:
                                goal_prop = True
                                break
                        for attrs in fusion.tipical_attrs:
                            if attrs[0] == goal_property and block[0][att] == '0':
                                found = False
                                break
                            elif attrs[0] == goal_property and block[0][att] == '1':
                                goal_prop = True
                                break
                            att += 1
                        if goal_prop == False:
                            found = False
                            break
                
                    if found:
                        return block[0]
        return None
    
    #salvo in un dizionario tutti gli oggetti dell'knowledge base con le proprietà in comune con il goal   
    def dictionary_object_knowledge_base_goal(self, knowledge_base , goal):
        property_in_common = {}
        for object_name in knowledge_base:
            property_in_common[object_name] = []
            for goal_property in goal:
               if goal_property in knowledge_base[object_name]:
                   property_in_common[object_name].append(goal_property)
        return property_in_common 
    
   
    #metodo che restituisce i concetti ordinati in maniera decrescente in base alle probabilità
    def list_order_by_probability(self, goal, knowledge_base):
        result = {}
        for object_name in knowledge_base:
            percentage = 0
            for goal_property in goal:
                if goal_property in knowledge_base[object_name]:
                    if knowledge_base[object_name][goal_property] is None:
                        percentage += 1
                    else:
                        percentage += float(knowledge_base[object_name][goal_property])
            if percentage != 0:
                result[object_name]= percentage
        print(result)
        return sorted(result, key=result.__getitem__, reverse=True)
    
    #metodo che restituisce True se ogni proprietà del goal è contenuta nelle proprietà dei due concetti passati come parametro
    #altrimenti restituisce False.
    def all_gaol_property(self, goal, property_object, property_object2):
        #copio il goal e rimuovo i dublicati se esistono
        goal_not_dublicate = goal.copy()
        i = 0
        for property_goal in goal_not_dublicate:
            j = 0
            for property_goal2 in goal_not_dublicate:
                if property_goal == property_goal2 and j > i:
                    goal.remove(property_goal2)
                    i = 0
                j += 1
            i+=1

       
        list_goal_property = [0] * len(goal_not_dublicate)
        for property_obj in property_object:
            if property_obj in goal:
                list_goal_property[goal_not_dublicate.index(property_obj)] = 1
        for property_obj in property_object2:
            if property_obj in goal:
                list_goal_property[goal_not_dublicate.index(property_obj)] = 1
            
        all_one = True
        for elem in list_goal_property:
            if elem == 0:
                all_one = False
                break
        return all_one
                   
if __name__ == '__main__' :
    f = ReadKnowledgeBase() 
    g = Goal() 
    
    print(g.all_gaol_property(g.goals[0],f.knowledge_base["hammer"], f.knowledge_base["stone"]))
  

