# -*- coding: utf-8 -*-
"""
Created on Wed Jan 30 18:36:50 2019

@author: Federico Perrone
"""

from pprint import *

class ReadKnowledgeBase:
    
    def __init__(self, path = 'knowledge_base') : 
        
        with open(path) as f:
            input_lines = f.readlines()
        input_lines = [x.strip() for x in input_lines 
                            if x.strip() != '' and x.strip()[0] != '\n']
        self.knowledge_base = {}
        for line in input_lines:
            line = line.split(",")
            line = [x.strip() for x in line if x.strip() != '']
            if len(line) == 3:
                object_name = line[0]
                object_property = line[1]
                object_probability = line[2]
                
                if object_name not in self.knowledge_base:
                    self.knowledge_base[object_name] = {}
                if object_property not in self.knowledge_base[object_name]:
                    self.knowledge_base[object_name][object_property] = object_probability
            elif len(line) == 2:
                object_name = line[0]
                object_property = line[1]
                if object_name not in self.knowledge_base:
                    self.knowledge_base[object_name] = {}
                if object_property not in self.knowledge_base[object_name]:
                    self.knowledge_base[object_name][object_property] = None
    
class HeadModifier:
    def __init__(self, head, modifier, knowledge_base):
        
            self.title = head + "-" + modifier
            self.head_conc = head
            self.mod_conc = modifier
            self.tipical_attrs = []
            self.attrs = []
            if head in knowledge_base: 
                for object_property in knowledge_base[head]:
                    if knowledge_base[head][object_property] is not None:
                        self.tipical_attrs.append((object_property, knowledge_base[head][object_property], True))
                    else:
                        self.attrs.append((object_property, True))
            if modifier in knowledge_base:
                for object_property in knowledge_base[modifier]:
                    if knowledge_base[modifier][object_property] is not None:
                        self.tipical_attrs.append((object_property, knowledge_base[modifier][object_property], False))
                    else:
                        self.attrs.append((object_property, False))
        
if __name__ == '__main__' :
    
    f = ReadKnowledgeBase() 
    pprint(f.knowledge_base)
# =============================================================================
#     a = HeadModifier("stick", "stone", f.knowledge_base)
#     print(a.tipical_attrs)
#     print(a.attrs)
# =============================================================================

