# -*- coding: utf-8 -*-
"""
Created on Tue Feb 12 19:29:32 2019

@author: Federico Perrone
"""
from nltk.corpus import wordnet as wn
#da fare: le parole attaccate all'altre vengono scritte con il _ ad esempio tracked_vehicle. Risolvere questo problema



#funzione che prende i lemmi del synset scelto dall'utente della parola presa in input attraverso l'uso di wordnet.
def word_synonyms(synset):
    result = set()
    for lemma in synset.lemmas():
        name = lemma.name().split("_")
        if len(name) > 1:
            word = ""
            for wo in name:
                 word += wo + " "
            result.add(word[:len(word)-1])
        else:
            result.add(lemma.name())
    return result
      

#funzione che prende in input una parola e la knowledge base e restituisce tutte le
# parole che sono sinonime della parola passata in input ma che siano presenti nella knowledge base
def synonyms_in_knowledge_base(synset, knowledge_base):
    synonyms_knowledge_base = set()
    synonyms = word_synonyms(synset)
    
    for object_name in knowledge_base:
        for synonym in synonyms:
            if synonym in knowledge_base[object_name].keys() :
                synonyms_knowledge_base.add(synonym)
                
    return synonyms_knowledge_base
#funzione che prende in input una parola e la knowledge base e restituisce tutte le
# parole che sono iponime della parola passata in input ma che siano presenti nella knowledge base
def hyponyms_in_knowledge_base(synset, knowledge_base):
    hyponyms_knowledge_base = set()
    hyponyms = word_hyponyms(synset)
    
    for object_name in knowledge_base:
        for hyponym in hyponyms:
            if hyponym in knowledge_base[object_name].keys() :
                 hyponyms_knowledge_base.add(hyponym)

    return hyponyms_knowledge_base
#funzione che prende in input una parola e la knowledge base e restituisce tutte le
# parole che sono iperonime della parola passata in input ma che siano presenti nella knowledge base
def hypernyms_in_knowledge_base(synset, knowledge_base):
    hypernyms_knowledge_base = set()
    hypernyms = word_hypernyms(synset)
    
    for object_name in knowledge_base:
        for hypernym in hypernyms:
            if hypernym in knowledge_base[object_name].keys() :
                 hypernyms_knowledge_base.add(hypernym)

    return hypernyms_knowledge_base

#funzione che prende tutti i peronimi(livello più basso della gerarchia) in base alla parola presa in input
def word_hyponyms(synset):
    result = set()    
    for hypo in synset.hyponyms():
        for lemma in hypo.lemmas():
            name = lemma.name().split("_")
            if len(name) > 1:
                word_into_result = ""
                for wo in name:
                    word_into_result += wo + " "
                result.add(word_into_result[:len(word_into_result)-1])
            else:
                result.add(lemma.name())
    return result
#funzione che prende tutti i iperonimi (livello più alto della gerarchia) in base alla parola presa in input
def word_hypernyms(synset):
    result = set()        
    for hyper in synset.hypernyms():
        for lemma in hyper.lemmas():
            name = lemma.name().split("_")
            if len(name) > 1:
                word_into_result = ""
                for wo in name:
                    word_into_result += wo + " "
                result.add(word_into_result[:len(word_into_result)-1])
            else:
                result.add(lemma.name())
    return result

#funzione che scambia due parole nella lista del gaol
def refine_goal(goal, word, word_replacement):
    new_goal = goal.copy()
    new_goal.remove(word)
    new_goal.append(word_replacement)
    return new_goal

#funzione che prende come parametro un goal (sotto forma di lista),
#una lista di parole che non sono prensenti nella knowledge base e viene passata anche la knowledge base
# restituisce una lista di gaol dove vengono presi tutti i sinonimi, iperonimi e iponimi delle parole passate in input 
#e vengono inseriti nei nuovi goal solo se le nuove parole sono contenute nella knowledge base.
#se nessuna nuova parola è presente nella knowledge base allora viene restituita una lista vuota.
def new_goal_synonyms_hypernym_hyponyms(goal, words, knowledge_base):
    new_goal = []
    i = 0
    for word in words:
        print("una parola non trovata è " + str(word))
        word_wordNet = word
        wo = word.split(" ")
        if len(wo) > 1:
            word_wordNet = "_".join(wo)

        number = -1
        j = 0
        synset = list()
        for syn in wn.synsets(word):
            synset.append(syn)
        if synset:
            not_int = False
            while number > j or number < 0 or not_int == False: 
                j = 0    
                for syn in synset:
                    hypernyms = hypernyms_in_knowledge_base(syn, knowledge_base)
                    hyponyms=   hyponyms_in_knowledge_base(syn, knowledge_base)
                    synonnyms = synonyms_in_knowledge_base(syn, knowledge_base)
                    union = synonnyms.union(hyponyms,hypernyms)
                    
                    print(str(j)+ " " + str(syn)+"----"+str(union))
                    j += 1
                input_terminal = input("Inserisci il numero del synset: ")
                try:
                        number = int(input_terminal)
                        not_int = True
                except ValueError:
                        number = -1
                   
                print(number)
                    
            hypernyms = hypernyms_in_knowledge_base(synset[number], knowledge_base)
            hyponyms=   hyponyms_in_knowledge_base(synset[number], knowledge_base)
            synonnyms = synonyms_in_knowledge_base(synset[number], knowledge_base)
            union = synonnyms.union(hyponyms,hypernyms)
            if i == 0:
                if union:
                    for word_wordnet in union:
                        go = refine_goal(goal,word,word_wordnet) 
                        new_goal.append(go)
                    goal = new_goal.copy()
                else:
                    i -= 1
                  
            else:
                new_goal = []
                if union:
                    for word_wordnet in union:
                        for go in goal:
                            go = refine_goal(go,word,word_wordnet) 
                            new_goal.append(go)
                    goal = new_goal.copy()
            i += 1

    return goal


